#!/bin/sh
#same version as MakeMyHMMproto.sh, but you can set everything on command line
# do.MyHMMproto.sh phoneme_list output_hmmdefs


#dict=$WORK_DIR/dict/dict
#hmmdefs_file=$WORK_DIR/HMM/40gauss.2

dict=$1
hmmdefs_file=$2

C=1.0

##########################################################
#make hmmdefs

#number of phonemes
num_phn=`wc $dict | awk '{print $1}'`

zero=""
for((i=0;$i<$num_phn;i++));do
  zero="$zero 0"
done


echo " ~o <VecSize> $num_phn <MFCC> " > $hmmdefs_file

count=0;
for phn in `cat $dict`; do
  tmp=""
  for((i=0;$i<$num_phn;i++));do
    if [ $i -eq $count ]; then
      tmp="$tmp $C"
    else
      tmp="$tmp 1e30"
    fi
  done
  count=$((count + 1))
  tmp_phn=`echo $phn | sed 's/\(.*\)__[0-9]/\1/'`


    echo "~s \"$phn\"
    <Mean> $num_phn
      $zero
    <Variance> $num_phn
      $tmp 
    <GConst> 0">> $hmmdefs_file

done


for phn in `cat $dict | grep -v -E "spk|pau|int"| sed 's/\(.*\)__[0-9]/\1/'|sort|uniq`; do
echo "~h \"$phn\"
 <BeginHMM>
   <NumStates> 5
   <State> 2 ~s \"${phn}__1\"
   <State> 3 ~s \"${phn}__2\"
   <State> 4 ~s \"${phn}__3\"
   <TransP> 5
      0  1   0   0   0
      0  0.5 0.5 0   0
      0  0   0.5 0.5 0
      0  0   0   0.5 0.5
      0  0   0   0   0
   <EndHMM>" >> $hmmdefs_file
done


echo "~h \"pau\"
 <BeginHMM>
   <NumStates> 11
   <State> 2 ~s \"pau__1\"
   <State> 3 ~s \"pau__2\"
   <State> 4 ~s \"pau__3\"
   <State> 5 ~s \"spk__1\"
   <State> 6 ~s \"spk__2\"
   <State> 7 ~s \"spk__3\"
   <State> 8 ~s \"int__1\"
   <State> 9 ~s \"int__2\"
   <State> 10 ~s \"int__3\"
   <TransP> 11
      0 0.33  0   0  0.33 0   0  0.33 0   0   0
      0  0.5 0.5  0   0   0   0   0   0   0   0
      0   0  0.5 0.5  0   0   0   0   0   0   0
      0  0.125  0  0.5 0.125  0   0  0.125  0   0  0.125
      0   0   0   0  0.5 0.5  0   0   0   0   0
      0   0   0   0   0  0.5 0.5  0   0   0   0
      0  0.125  0   0  0.125  0  0.5 0.125  0   0  0.125
      0   0   0   0   0   0   0  0.5 0.5  0   0
      0   0   0   0   0   0   0   0  0.5 0.5  0
      0  0.125  0   0  0.125  0   0  0.125  0  0.5 0.125
      0   0   0   0   0   0   0   0   0   0   0
 <EndHMM>
" >> $hmmdefs_file
